<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Color Workshop</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<?php
/***************************************************************************
	DHTML Color Workshop by Chris Marshall
	
	This is a simple DHTML "color workshop" script that can be used to select a site color theme.
	
	It is meant to be integrated into a PHP-Nuke or PostNuke portal system that has been set up
	to coordinate a web site design, but this file can be used standalone. It is not being presented
	as a module.
	
	I use PHP to generate the color table, but you could also use JavaScript, or even just copy
	the resultant HTML and use it directly.
	
	It's pretty basic, I could make it a lot friendlier by adding onChange handlers to the text
	areas to change the navigation areas when you type or paste. I could also make the BBCode
	URL generate dynamically, in real time. I could also do away with the radio buttons, and just
	make it so you click on a swatch, then a navigation area.
	
	Version 1.0.2
*/

/***************************************************************************
	This function creates a color swatch table, and populates it with onClick
	handlers to switch the styles of the page navigation and content areas.
*/

global	$self_ref;

// Strip out the path up to the script.
$self_ref = preg_replace ( "|\/(.*)\/|", "", $_SERVER['SCRIPT_NAME'] );

function create_color_table()
{
	global $self_ref, $area_picked, $topnav_text, $topnav_textcolor, $left, $left_textcolor, $left_insert, $left_insert_textcolor, $bottom, $bottom_textcolor, $content, $document, $document_textcolor, $page_title, $topnav_pinstripe, $left_pinstripe;
	
	// Generate a list of radio buttons and text fields to display the value and selected area.
	$ret = "<form action=\"\" method=\"get\" id=\"color_picker\" name=\"color_picker\">\n";
	$ret .= "<input type=\"hidden\" name=\"area_picked\" value=\"$area_picked\">";
	$ret .= "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n";
	$ret .= "<tr>\n";
	$ret .= "<td colspan=\"6\"><input type=\"text\" size=\"7\" maxlength=\"6\" name=\"topnav_text\" value=\"$topnav_text\"></td>\n";
	$ret .= "<td align=\"right\" colspan=\"3\"><input type=\"radio\" name=\"area_pick\" value=\"topnav\"";
	if ( $area_picked == 'topnav' ) $ret .= " checked";
	$ret .= " onClick=\"this.form.area_picked.value=this.value\"></td>\n";
	$ret .= "<td colspan=\"34\">Top Navigation Area</td>\n";
	$ret .= "</tr>\n";
	$ret .= "<tr>\n";
	$ret .= "<td colspan=\"6\"><input type=\"text\" size=\"7\" maxlength=\"6\" name=\"topnav_pinstripe_text\" value=\"$topnav_pinstripe\"></td>\n";
	$ret .= "<td align=\"right\" colspan=\"3\"><input type=\"radio\" name=\"area_pick\" value=\"topnav_pinstripe\"";
	if ( $area_picked == 'topnav_pinstripe' ) $ret .= " checked";
	$ret .= " onClick=\"this.form.area_picked.value=this.value\"></td>\n";
	$ret .= "<td colspan=\"34\">Top Navigation &quot;pin stripe&quot;</td>\n";
	$ret .= "</tr>\n";
	$ret .= "<tr>\n";
	$ret .= "<td colspan=\"6\"><input type=\"text\" size=\"7\" maxlength=\"6\" name=\"topnav_textcolor_text\" value=\"$topnav_textcolor\"></td>\n";
	$ret .= "<td align=\"right\" colspan=\"3\"><input type=\"radio\" name=\"area_pick\" value=\"topnav_textcolor\"";
	if ( $area_picked == 'topnav_textcolor' ) $ret .= " checked";
	$ret .= " onClick=\"this.form.area_picked.value=this.value\"></td>\n";
	$ret .= "<td colspan=\"34\">Top Navigation Area Text</td>\n";
	$ret .= "</tr>\n";
	$ret .= "<tr>\n";
	$ret .= "<td colspan=\"6\"><input type=\"text\" size=\"7\" maxlength=\"6\" name=\"left_text\" value=\"$left\"></td>\n";
	$ret .= "<td align=\"right\" colspan=\"3\"><input type=\"radio\" name=\"area_pick\" value=\"left\"";
	if ( $area_picked == 'left' ) $ret .= " checked";
	$ret .= " onClick=\"this.form.area_picked.value=this.value\"></td>\n";
	$ret .= "<td colspan=\"34\">Left Navigation Area</td>\n";
	$ret .= "</tr>\n";
	$ret .= "<tr>\n";
	$ret .= "<td colspan=\"6\"><input type=\"text\" size=\"7\" maxlength=\"6\" name=\"left_pinstripe_text\" value=\"$left_pinstripe\"></td>\n";
	$ret .= "<td align=\"right\" colspan=\"3\"><input type=\"radio\" name=\"area_pick\" value=\"left_pinstripe\"";
	if ( $area_picked == 'left_pinstripe' ) $ret .= " checked";
	$ret .= " onClick=\"this.form.area_picked.value=this.value\"></td>\n";
	$ret .= "<td colspan=\"34\">Left Navigation &quot;pin stripe&quot;</td>\n";
	$ret .= "</tr>\n";
	$ret .= "<tr>\n";
	$ret .= "<td colspan=\"6\"><input type=\"text\" size=\"7\" maxlength=\"6\" name=\"left_textcolor_text\" value=\"$left_textcolor\"></td>\n";
	$ret .= "<td align=\"right\" colspan=\"3\"><input type=\"radio\" name=\"area_pick\" value=\"left_textcolor\"";
	if ( $area_picked == 'left_textcolor' ) $ret .= " checked";
	$ret .= " onClick=\"this.form.area_picked.value=this.value\"></td>\n";
	$ret .= "<td colspan=\"34\">Left Navigation Area Text</td>\n";
	$ret .= "</tr>\n";
	$ret .= "<tr>\n";
	$ret .= "<td colspan=\"6\"><input type=\"text\" size=\"7\" maxlength=\"6\" name=\"left_insert_text\" value=\"$left_insert\"></td>\n";
	$ret .= "<td align=\"right\" colspan=\"3\"><input type=\"radio\" name=\"area_pick\" value=\"left_insert\"";
	if ( $area_picked == 'left_insert' ) $ret .= " checked";
	$ret .= " onClick=\"this.form.area_picked.value=this.value\"></td>\n";
	$ret .= "<td colspan=\"34\">Left Navigation Insert</td>\n";
	$ret .= "</tr>\n";
	$ret .= "<tr>\n";
	$ret .= "<td colspan=\"6\"><input type=\"text\" size=\"7\" maxlength=\"6\" name=\"left_insert_textcolor_text\" value=\"$left_insert_textcolor\"></td>\n";
	$ret .= "<td align=\"right\" colspan=\"3\"><input type=\"radio\" name=\"area_pick\" value=\"left_insert_textcolor\"";
	if ( $area_picked == 'left_insert_textcolor' ) $ret .= " checked";
	$ret .= " onClick=\"this.form.area_picked.value=this.value\"></td>\n";
	$ret .= "<td colspan=\"34\">Left Navigation Insert Text</td>\n";
	$ret .= "</tr>\n";
	$ret .= "<tr>\n";
	$ret .= "<td colspan=\"6\"><input type=\"text\" size=\"7\" maxlength=\"6\" name=\"bottom_text\" value=\"$bottom\"></td>\n";
	$ret .= "<td align=\"right\" colspan=\"3\"><input type=\"radio\" name=\"area_pick\" value=\"bottom\"";
	if ( $area_picked == 'bottom' ) $ret .= " checked";
	$ret .= " onClick=\"this.form.area_picked.value=this.value\"></td>\n";
	$ret .= "<td colspan=\"34\">Bottom Navigation Area</td>\n";
	$ret .= "</tr>\n";
	$ret .= "<tr>\n";
	$ret .= "<td colspan=\"6\"><input type=\"text\" size=\"7\" maxlength=\"6\" name=\"bottom_textcolor_text\" value=\"$bottom_textcolor\"></td>\n";
	$ret .= "<td align=\"right\" colspan=\"3\"><input type=\"radio\" name=\"area_pick\" value=\"bottom_textcolor\"";
	if ( $area_picked == 'bottom_textcolor' ) $ret .= " checked";
	$ret .= " onClick=\"this.form.area_picked.value=this.value\"></td>\n";
	$ret .= "<td colspan=\"34\">Bottom Navigation Area Text</td>\n";
	$ret .= "</tr>\n";
	$ret .= "<tr>\n";
	$ret .= "<td colspan=\"6\"><input type=\"text\" size=\"7\" maxlength=\"6\" name=\"content_text\" value=\"$content\"></td>\n";
	$ret .= "<td align=\"right\" colspan=\"3\"><input type=\"radio\" name=\"area_pick\" value=\"content\"";
	if ( $area_picked == 'content' ) $ret .= " checked";
	$ret .= " onClick=\"this.form.area_picked.value=this.value\"></td>\n";
	$ret .= "<td colspan=\"34\">Content Area</td>\n";
	$ret .= "</tr>\n";
	$ret .= "<tr>\n";
	$ret .= "<td colspan=\"6\"><input type=\"text\" size=\"7\" maxlength=\"6\" name=\"document_text\" value=\"$document\"></td>\n";
	$ret .= "<td align=\"right\" colspan=\"3\"><input type=\"radio\" name=\"area_pick\" value=\"document\"";
	if ( $area_picked == 'document' ) $ret .= " checked";
	$ret .= " onClick=\"this.form.area_picked.value=this.value\"></td>\n";
	$ret .= "<td colspan=\"34\">Document Background</td>\n";
	$ret .= "</tr>\n";
	$ret .= "<tr>\n";
	$ret .= "<td colspan=\"6\"><input type=\"text\" size=\"7\" maxlength=\"6\" name=\"document_textcolor_text\" value=\"$document_textcolor\"></td>\n";
	$ret .= "<td align=\"right\" colspan=\"3\"><input type=\"radio\" name=\"area_pick\" value=\"document_textcolor\"";
	if ( $area_picked == 'document_textcolor' ) $ret .= " checked";
	$ret .= " onClick=\"this.form.area_picked.value=this.value\"></td>\n";
	$ret .= "<td colspan=\"34\">Main Document Text</td>\n";
	$ret .= "</tr>\n";
	$ret .= "<tr>\n";
	$ret .= "<td colspan=\"6\">&nbsp;</td>\n";
	// Here, we allow the user to enter a name for the theme (for use in the BBCode URL)
	$ret .= "<td colspan=\"37\">Theme Name:&nbsp;<input type=\"text\" size=\"24\" maxlength=\"64\" name=\"page_title\" value=\"$page_title\">&nbsp;<input type=\"submit\" value=\"Submit This Color Theme\"></td>\n";
	$ret .= "</tr>\n";
	$ret .= "<tr>\n";
	$ret .= "<td colspan=\"6\">&nbsp;</td>\n";
	$ret .= "<td colspan=\"37\"><a href=\"$self_ref\">Revert to Default (Gray) Theme</a></td>\n";
	$ret .= "</tr>\n";
	$ret .= "<tr>\n";
	$ret .= "<td colspan=\"43\">&nbsp;</td>\n";
	$ret .= "</tr>\n";
	$ret .= "<tr bgcolor=\"#000000\">\n";
	$ret .= "<td colspan=\"43\">&nbsp;</td>\n";
	$ret .= "</tr>\n";
	
	// Here is where the color table is generated. We start with six areas of 36 swatches that
	// represent the entire web safe palette.
	$red = 0x00;
	$color_array = array ();
	
	while ( $red < 0x100 )
		{
		$green = 0x00;
		while ( $green < 0x100 )
			{
			$blue = 0x00;
			while ( $blue < 0x100 )
				{
				$color = sprintf("%02X%02X%02X", $red, $green, $blue );
				array_push ( $color_array, $color );
				$blue += 0x33;
				}
			$green += 0x33;
			}
		$red += 0x33;
		}

	$row = 0;
	foreach ( $color_array as $color )
		{
		if ( !$row )
			{
			$ret .= "<tr bgcolor=\"#000000\">\n<td>&nbsp;</td>\n";
			$row = 1;
			$col = 0;
			}
		
		// We create an onClick handler for each filler image.
		$onClick = "var a=document.color_picker.area_picked.value;";
		$onClick .= " var t='table_'+a;";
		$onClick .= " if(a.search('_textcolor')>-1){t='table_'+a.substr(0,a.search('_textcolor'))};";
		$onClick .= " var r=document.getElementById(t);";
		$onClick .= " var e='document.color_picker.'+a+'_text.value=\'$color\';';";
		$onClick .= " e+=' document.color_picker.'+a+'_text.select();';";
		$onClick .= " eval(e);";
		$onClick .= " if(a.search('document')==-1){if(a.search('_textcolor')>-1){r.style.color='#$color'}else{r.style.backgroundColor='#$color'}}else{if(a.search('_textcolor')>-1){body.color='#$color'}else{document.body.style.backgroundColor='#$color'}};";
		
		$ret .= "<td bgcolor=\"#$color\"><a href=\"#_PageTop\"><img onClick=\"$onClick\" src=\"../images/shim.gif\" alt=\"spacer\" width=\"16\" height=\"16\" border=\"0\" onMouseOver=\"document.color_picker.show_value.value='$color'\" onMouseOut=\"document.color_picker.show_value.value=''\"></a></td>\n";
		$col++;
		if ( !($col % 6) )
			{
			$ret .= "<td>&nbsp;</td>\n";
			}
		
		if ( $col > 35 )
			{
			$row = 0;
			}
			
		if ( !$row )
			{
			$ret .= "</tr>\n";
			}
		}

	$ret .= "<tr bgcolor=\"#000000\">\n";
	$ret .= "<td colspan=\"43\">&nbsp;</td>\n";
	$ret .= "</tr>\n";
	
	// Now, we have eight more swatch rows that separate some related colors into easier to see areas
	$ret .= "<tr bgcolor=\"#000000\">\n";
	$ret .= "<td>&nbsp;</td>\n";
	$ret .= "<td colspan=\"41\"><table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n<tr>\n";
	// red ramp
	for ( $grey = 0x00; $grey < 0x100; $grey += 0x33 )
		{
		$color = sprintf("%02X0000", $grey );
		$onClick = "var a=document.color_picker.area_picked.value;";
		$onClick .= " var t='table_'+a;";
		$onClick .= " if(a.search('_textcolor')>-1){t='table_'+a.substr(0,a.search('_textcolor'))};";
		$onClick .= " var r=document.getElementById(t);";
		$onClick .= " var e='document.color_picker.'+a+'_text.value=\'$color\';';";
		$onClick .= " e+=' document.color_picker.'+a+'_text.select();';";
		$onClick .= " eval(e);";
		$onClick .= " if(a.search('document')==-1){if(a.search('_textcolor')>-1){r.style.color='#$color'}else{r.style.backgroundColor='#$color'}}else{if(a.search('_textcolor')>-1){body.color='#$color'}else{document.body.style.backgroundColor='#$color'}};";
		$ret .= "<td bgcolor=\"#$color\"><a href=\"#_PageTop\"><img onClick=\"$onClick\" src=\"../images/shim.gif\" alt=\"spacer\" width=\"16\" height=\"16\" border=\"0\" onMouseOver=\"document.color_picker.show_value.value='$color'\" onMouseOut=\"document.color_picker.show_value.value=''\"></a></td>\n";
		}
	$ret .= "<td>&nbsp;</td>\n";
	// green ramp
	for ( $grey = 0x00; $grey < 0x100; $grey += 0x33 )
		{
		$color = sprintf("00%02X00", $grey );
		$onClick = "var a=document.color_picker.area_picked.value;";
		$onClick .= " var t='table_'+a;";
		$onClick .= " if(a.search('_textcolor')>-1){t='table_'+a.substr(0,a.search('_textcolor'))};";
		$onClick .= " var r=document.getElementById(t);";
		$onClick .= " var e='document.color_picker.'+a+'_text.value=\'$color\';';";
		$onClick .= " e+=' document.color_picker.'+a+'_text.select();';";
		$onClick .= " eval(e);";
		$onClick .= " if(a.search('document')==-1){if(a.search('_textcolor')>-1){r.style.color='#$color'}else{r.style.backgroundColor='#$color'}}else{if(a.search('_textcolor')>-1){body.color='#$color'}else{document.body.style.backgroundColor='#$color'}};";
		$ret .= "<td bgcolor=\"#$color\"><a href=\"#_PageTop\"><img onClick=\"$onClick\" src=\"../images/shim.gif\" alt=\"spacer\" width=\"16\" height=\"16\" border=\"0\" onMouseOver=\"document.color_picker.show_value.value='$color'\" onMouseOut=\"document.color_picker.show_value.value=''\"></a></td>\n";
		}
	$ret .= "<td>&nbsp;</td>\n";
	// blue ramp
	for ( $grey = 0x00; $grey < 0x100; $grey += 0x33 )
		{
		$color = sprintf("0000%02X", $grey );
		$onClick = "var a=document.color_picker.area_picked.value;";
		$onClick .= " var t='table_'+a;";
		$onClick .= " if(a.search('_textcolor')>-1){t='table_'+a.substr(0,a.search('_textcolor'))};";
		$onClick .= " var r=document.getElementById(t);";
		$onClick .= " var e='document.color_picker.'+a+'_text.value=\'$color\';';";
		$onClick .= " e+=' document.color_picker.'+a+'_text.select();';";
		$onClick .= " eval(e);";
		$onClick .= " if(a.search('document')==-1){if(a.search('_textcolor')>-1){r.style.color='#$color'}else{r.style.backgroundColor='#$color'}}else{if(a.search('_textcolor')>-1){body.color='#$color'}else{document.body.style.backgroundColor='#$color'}};";
		$ret .= "<td bgcolor=\"#$color\"><a href=\"#_PageTop\"><img onClick=\"$onClick\" src=\"../images/shim.gif\" alt=\"spacer\" width=\"16\" height=\"16\" border=\"0\" onMouseOver=\"document.color_picker.show_value.value='$color'\" onMouseOut=\"document.color_picker.show_value.value=''\"></a></td>\n";
		}
	$ret .= "<td>&nbsp;</td>\n";
	// yellow ramp
	for ( $grey = 0x00; $grey < 0x100; $grey += 0x33 )
		{
		$color = sprintf("%02X%02X00", $grey, $grey );
		$onClick = "var a=document.color_picker.area_picked.value;";
		$onClick .= " var t='table_'+a;";
		$onClick .= " if(a.search('_textcolor')>-1){t='table_'+a.substr(0,a.search('_textcolor'))};";
		$onClick .= " var r=document.getElementById(t);";
		$onClick .= " var e='document.color_picker.'+a+'_text.value=\'$color\';';";
		$onClick .= " e+=' document.color_picker.'+a+'_text.select();';";
		$onClick .= " eval(e);";
		$onClick .= " if(a.search('document')==-1){if(a.search('_textcolor')>-1){r.style.color='#$color'}else{r.style.backgroundColor='#$color'}}else{if(a.search('_textcolor')>-1){body.color='#$color'}else{document.body.style.backgroundColor='#$color'}};";
		$ret .= "<td bgcolor=\"#$color\"><a href=\"#_PageTop\"><img onClick=\"$onClick\" src=\"../images/shim.gif\" alt=\"spacer\" width=\"16\" height=\"16\" border=\"0\" onMouseOver=\"document.color_picker.show_value.value='$color'\" onMouseOut=\"document.color_picker.show_value.value=''\"></a></td>\n";
		}
	$ret .= "<td>&nbsp;</td>\n";
	// cyan ramp
	for ( $grey = 0x00; $grey < 0x100; $grey += 0x33 )
		{
		$color = sprintf("00%02X%02X", $grey, $grey );
		$onClick = "var a=document.color_picker.area_picked.value;";
		$onClick .= " var t='table_'+a;";
		$onClick .= " if(a.search('_textcolor')>-1){t='table_'+a.substr(0,a.search('_textcolor'))};";
		$onClick .= " var r=document.getElementById(t);";
		$onClick .= " var e='document.color_picker.'+a+'_text.value=\'$color\';';";
		$onClick .= " e+=' document.color_picker.'+a+'_text.select();';";
		$onClick .= " eval(e);";
		$onClick .= " if(a.search('document')==-1){if(a.search('_textcolor')>-1){r.style.color='#$color'}else{r.style.backgroundColor='#$color'}}else{if(a.search('_textcolor')>-1){body.color='#$color'}else{document.body.style.backgroundColor='#$color'}};";
		$ret .= "<td bgcolor=\"#$color\"><a href=\"#_PageTop\"><img onClick=\"$onClick\" src=\"../images/shim.gif\" alt=\"spacer\" width=\"16\" height=\"16\" border=\"0\" onMouseOver=\"document.color_picker.show_value.value='$color'\" onMouseOut=\"document.color_picker.show_value.value=''\"></a></td>\n";
		}
	$ret .= "<td>&nbsp;</td>\n";
	// magenta ramp
	for ( $grey = 0x00; $grey < 0x100; $grey += 0x33 )
		{
		$color = sprintf("%02X00%02X", $grey, $grey );
		$onClick = "var a=document.color_picker.area_picked.value;";
		$onClick .= " var t='table_'+a;";
		$onClick .= " if(a.search('_textcolor')>-1){t='table_'+a.substr(0,a.search('_textcolor'))};";
		$onClick .= " var r=document.getElementById(t);";
		$onClick .= " var e='document.color_picker.'+a+'_text.value=\'$color\';';";
		$onClick .= " e+=' document.color_picker.'+a+'_text.select();';";
		$onClick .= " eval(e);";
		$onClick .= " if(a.search('document')==-1){if(a.search('_textcolor')>-1){r.style.color='#$color'}else{r.style.backgroundColor='#$color'}}else{if(a.search('_textcolor')>-1){body.color='#$color'}else{document.body.style.backgroundColor='#$color'}};";
		$ret .= "<td bgcolor=\"#$color\"><a href=\"#_PageTop\"><img onClick=\"$onClick\" src=\"../images/shim.gif\" alt=\"spacer\" width=\"16\" height=\"16\" border=\"0\" onMouseOver=\"document.color_picker.show_value.value='$color'\" onMouseOut=\"document.color_picker.show_value.value=''\"></a></td>\n";
		}
	$ret .= "</tr>\n</table>\n</td>\n";
	$ret .= "<td>&nbsp;</td>\n";
	$ret .= "</tr>\n";
	
	$ret .= "<tr bgcolor=\"#000000\">\n";
	$ret .= "<td colspan=\"43\">&nbsp;</td>\n";
	$ret .= "</tr>\n";

	$ret .= "<tr bgcolor=\"#000000\">\n";
	$ret .= "<td>&nbsp;</td>\n";
	$ret .= "<td colspan=\"13\"><table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n<tr>\n";
	// gray ramp
	for ( $grey = 0x00; $grey < 0x100; $grey += 0x33 )
		{
		$color = sprintf("%02X%02X%02X", $grey, $grey, $grey );
		$onClick = "var a=document.color_picker.area_picked.value;";
		$onClick .= " var t='table_'+a;";
		$onClick .= " if(a.search('_textcolor')>-1){t='table_'+a.substr(0,a.search('_textcolor'))};";
		$onClick .= " var r=document.getElementById(t);";
		$onClick .= " var e='document.color_picker.'+a+'_text.value=\'$color\';';";
		$onClick .= " e+=' document.color_picker.'+a+'_text.select();';";
		$onClick .= " eval(e);";
		$onClick .= " if(a.search('document')==-1){if(a.search('_textcolor')>-1){r.style.color='#$color'}else{r.style.backgroundColor='#$color'}}else{if(a.search('_textcolor')>-1){body.color='#$color'}else{document.body.style.backgroundColor='#$color'}};";
		$ret .= "<td bgcolor=\"#$color\"><a href=\"#_PageTop\"><img onClick=\"$onClick\" src=\"../images/shim.gif\" alt=\"spacer\" width=\"16\" height=\"16\" border=\"0\" onMouseOver=\"document.color_picker.show_value.value='$color'\" onMouseOut=\"document.color_picker.show_value.value=''\"></a></td>\n";
		}
	$ret .= "<td>&nbsp;</td>\n";
	
	// Now, we display a row of full-saturation versions of each primary color: RGBCMY
	$color = "FF0000";
	$onClick = "var a=document.color_picker.area_picked.value;";
	$onClick .= " var t='table_'+a;";
	$onClick .= " if(a.search('_textcolor')>-1){t='table_'+a.substr(0,a.search('_textcolor'))};";
	$onClick .= " var r=document.getElementById(t);";
	$onClick .= " var e='document.color_picker.'+a+'_text.value=\'$color\';';";
	$onClick .= " e+=' document.color_picker.'+a+'_text.select();';";
	$onClick .= " eval(e);";
	$onClick .= " if(a.search('document')==-1){if(a.search('_textcolor')>-1){r.style.color='#$color'}else{r.style.backgroundColor='#$color'}}else{if(a.search('_textcolor')>-1){body.color='#$color'}else{document.body.style.backgroundColor='#$color'}};";
	$ret .= "<td bgcolor=\"#$color\"><a href=\"#_PageTop\"><img onClick=\"$onClick\" src=\"../images/shim.gif\" alt=\"spacer\" width=\"16\" height=\"16\" border=\"0\" onMouseOver=\"document.color_picker.show_value.value='$color'\" onMouseOut=\"document.color_picker.show_value.value=''\"></a></td>\n";

	$color = "00FF00";
	$onClick = "var a=document.color_picker.area_picked.value;";
	$onClick .= " var t='table_'+a;";
	$onClick .= " if(a.search('_textcolor')>-1){t='table_'+a.substr(0,a.search('_textcolor'))};";
	$onClick .= " var r=document.getElementById(t);";
	$onClick .= " var e='document.color_picker.'+a+'_text.value=\'$color\';';";
	$onClick .= " e+=' document.color_picker.'+a+'_text.select();';";
	$onClick .= " eval(e);";
	$onClick .= " if(a.search('document')==-1){if(a.search('_textcolor')>-1){r.style.color='#$color'}else{r.style.backgroundColor='#$color'}}else{if(a.search('_textcolor')>-1){body.color='#$color'}else{document.body.style.backgroundColor='#$color'}};";
	$ret .= "<td bgcolor=\"#$color\"><a href=\"#_PageTop\"><img onClick=\"$onClick\" src=\"../images/shim.gif\" alt=\"spacer\" width=\"16\" height=\"16\" border=\"0\" onMouseOver=\"document.color_picker.show_value.value='$color'\" onMouseOut=\"document.color_picker.show_value.value=''\"></a></td>\n";

	$color = "0000FF";
	$onClick = "var a=document.color_picker.area_picked.value;";
	$onClick .= " var t='table_'+a;";
	$onClick .= " if(a.search('_textcolor')>-1){t='table_'+a.substr(0,a.search('_textcolor'))};";
	$onClick .= " var r=document.getElementById(t);";
	$onClick .= " var e='document.color_picker.'+a+'_text.value=\'$color\';';";
	$onClick .= " e+=' document.color_picker.'+a+'_text.select();';";
	$onClick .= " eval(e);";
	$onClick .= " if(a.search('document')==-1){if(a.search('_textcolor')>-1){r.style.color='#$color'}else{r.style.backgroundColor='#$color'}}else{if(a.search('_textcolor')>-1){body.color='#$color'}else{document.body.style.backgroundColor='#$color'}};";
	$ret .= "<td bgcolor=\"#$color\"><a href=\"#_PageTop\"><img onClick=\"$onClick\" src=\"../images/shim.gif\" alt=\"spacer\" width=\"16\" height=\"16\" border=\"0\" onMouseOver=\"document.color_picker.show_value.value='$color'\" onMouseOut=\"document.color_picker.show_value.value=''\"></a></td>\n";

	$color = "FFFF00";
	$onClick = "var a=document.color_picker.area_picked.value;";
	$onClick .= " var t='table_'+a;";
	$onClick .= " if(a.search('_textcolor')>-1){t='table_'+a.substr(0,a.search('_textcolor'))};";
	$onClick .= " var r=document.getElementById(t);";
	$onClick .= " var e='document.color_picker.'+a+'_text.value=\'$color\';';";
	$onClick .= " e+=' document.color_picker.'+a+'_text.select();';";
	$onClick .= " eval(e);";
	$onClick .= " if(a.search('document')==-1){if(a.search('_textcolor')>-1){r.style.color='#$color'}else{r.style.backgroundColor='#$color'}}else{if(a.search('_textcolor')>-1){body.color='#$color'}else{document.body.style.backgroundColor='#$color'}};";
	$ret .= "<td bgcolor=\"#$color\"><a href=\"#_PageTop\"><img onClick=\"$onClick\" src=\"../images/shim.gif\" alt=\"spacer\" width=\"16\" height=\"16\" border=\"0\" onMouseOver=\"document.color_picker.show_value.value='$color'\" onMouseOut=\"document.color_picker.show_value.value=''\"></a></td>\n";

	$color = "FF00FF";
	$onClick = "var a=document.color_picker.area_picked.value;";
	$onClick .= " var t='table_'+a;";
	$onClick .= " if(a.search('_textcolor')>-1){t='table_'+a.substr(0,a.search('_textcolor'))};";
	$onClick .= " var r=document.getElementById(t);";
	$onClick .= " var e='document.color_picker.'+a+'_text.value=\'$color\';';";
	$onClick .= " e+=' document.color_picker.'+a+'_text.select();';";
	$onClick .= " eval(e);";
	$onClick .= " if(a.search('document')==-1){if(a.search('_textcolor')>-1){r.style.color='#$color'}else{r.style.backgroundColor='#$color'}}else{if(a.search('_textcolor')>-1){body.color='#$color'}else{document.body.style.backgroundColor='#$color'}};";
	$ret .= "<td bgcolor=\"#$color\"><a href=\"#_PageTop\"><img onClick=\"$onClick\" src=\"../images/shim.gif\" alt=\"spacer\" width=\"16\" height=\"16\" border=\"0\" onMouseOver=\"document.color_picker.show_value.value='$color'\" onMouseOut=\"document.color_picker.show_value.value=''\"></a></td>\n";

	$color = "00FFFF";
	$onClick = "var a=document.color_picker.area_picked.value;";
	$onClick .= " var t='table_'+a;";
	$onClick .= " if(a.search('_textcolor')>-1){t='table_'+a.substr(0,a.search('_textcolor'))};";
	$onClick .= " var r=document.getElementById(t);";
	$onClick .= " var e='document.color_picker.'+a+'_text.value=\'$color\';';";
	$onClick .= " e+=' document.color_picker.'+a+'_text.select();';";
	$onClick .= " eval(e);";
	$onClick .= " if(a.search('document')==-1){if(a.search('_textcolor')>-1){r.style.color='#$color'}else{r.style.backgroundColor='#$color'}}else{if(a.search('_textcolor')>-1){body.color='#$color'}else{document.body.style.backgroundColor='#$color'}};";
	$ret .= "<td bgcolor=\"#$color\"><a href=\"#_PageTop\"><img onClick=\"$onClick\" src=\"../images/shim.gif\" alt=\"spacer\" width=\"16\" height=\"16\" border=\"0\" onMouseOver=\"document.color_picker.show_value.value='$color'\" onMouseOut=\"document.color_picker.show_value.value=''\"></a></td>\n";

	$ret .= "</tr>\n</table>\n</td>\n";
	$ret .= "<td>&nbsp;</td>\n";
	$ret .= "<td valign=\"top\" colspan=\"28\"><div style=\"color: #FFFFFF; font-size: x-small\">Current Value:&nbsp;<input type=\"text\" size=\"7\" maxlength=\"6\" name=\"show_value\" value=\"\" readonly>&nbsp;(Web safe colors)</div></td>\n";
	$ret .= "</tr>\n";

	$ret .= "<tr bgcolor=\"#000000\">\n";
	$ret .= "<td colspan=\"43\">&nbsp;</td>\n";
	$ret .= "</tr>\n";
	
	// This is where we display a BBCode URL
	$ret .= "</table>\n<br>\n";
	$query = getenv('QUERY_STRING');
	if ( $query ) $query = "?".htmlspecialchars($query);
	$ret .= "The BBCode URL for this page is:<br>";
	$ret .= "<textarea readonly style=\"font-size: xx-small\" cols=\"80\" rows=\"6\">[URL=http://www.cmarshall.net/misc/$self_ref$query]".htmlspecialchars($page_title)."[/URL]</textarea>\n";
	$ret .= "</form>\n";
	
	return $ret;
}

// Here, we read the parameters, and set up our globals
$topnav_text = $_GET['topnav_text'];
$topnav_pinstripe = $_GET['topnav_pinstripe_text'];
$topnav_textcolor = $_GET['topnav_textcolor_text'];
$left = $_GET['left_text'];
$left_pinstripe = $_GET['left_pinstripe_text'];
$left_textcolor = $_GET['left_textcolor_text'];
$left_insert = $_GET['left_insert_text'];
$left_insert_textcolor = $_GET['left_insert_textcolor_text'];
$bottom = $_GET['bottom_text'];
$bottom_textcolor = $_GET['bottom_textcolor_text'];
$content = $_GET['content_text'];
$document = $_GET['document_text'];
$document_textcolor = $_GET['document_textcolor_text'];
$area_picked = $_GET['area_picked'];
$page_title = $_GET['page_title'];

// These are defaults
if ( !$page_title ) $page_title = "Example Color Theme";
if ( !$topnav_text ) $topnav_text = "999999";
if ( !$topnav_pinstripe ) $topnav_pinstripe = $topnav_text;
if ( !$topnav_textcolor ) $topnav_textcolor = "000033";
if ( !$left ) $left = "999999";
if ( !$left_pinstripe ) $left_pinstripe = $left;
if ( !$left_textcolor ) $left_textcolor = "000033";
if ( !$left_insert ) $left_insert = "FFFFFF";
if ( !$left_insert_textcolor ) $left_insert_textcolor = "000033";
if ( !$bottom ) $bottom = "999999";
if ( !$bottom_textcolor ) $bottom_textcolor = "000033";
if ( !$content ) $content = "FFFFFF";
if ( !$document ) $document = "FFFFFF";
if ( !$document_textcolor ) $document_textcolor = "000033";
if ( !$area_picked ) $area_picked = "topnav";

// I don't like messing with links, so the values are hardcoded here.
$text_color_a = "0033CC";
$text_color_a_visited = "000099";
$text_color_a_hover= "CC0033";

?>
<!-- These styles are dynamically generated using PHP -->
<style type="text/css">
body {
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: small;
	color: #<?php echo $document_textcolor; ?>;
	background-color: #<?php echo $document; ?>;
}
a {
	color: #<?php echo $text_color_a; ?>;
}
a:visited {
	color: #<?php echo $text_color_a_visited; ?>;
}
a:hover {
	color: #<?php echo $text_color_a_hover; ?>;
	text-decoration: none;
}

.class_topnav {
	background-color: #<?php echo $topnav_text; ?>;
	color: #<?php echo $topnav_textcolor; ?>;
	font-weight: bold;
}
.class_topnav_pinstripe {
	background-color: #<?php echo $topnav_pinstripe; ?>;
}
.class_left {
	background-color: #<?php echo $left; ?>;
	color: #<?php echo $left_textcolor; ?>;
	font-size: x-small;
	font-weight: bold;
}
.class_left_pinstripe {
	background-color: #<?php echo $left_pinstripe; ?>;
}
.class_left_insert {
	background-color: #<?php echo $left_insert; ?>;
	color: #<?php echo $left_insert_textcolor; ?>;
	font-size: x-small;
	font-weight: bold;
}
.class_bottom {
	background-color: #<?php echo $bottom; ?>;
	color: #<?php echo $bottom_textcolor; ?>;
	font-size: x-small;
}
.class_content {
	background-color: #<?php echo $content; ?>;
}
</style>

</head>

<body>
	<a name="_PageTop"></a><table width="600" border="0" align="center" cellpadding="0" cellspacing="0">
		<tr valign="top" class="class_topnav" id="table_topnav">
			<td colspan="2" width="130">This is the space to put the logo.</td>
			<td colspan="2">This is the top navigation area. <a href="#_PageTop" target="_top">This is a Link</a> </td>
		</tr>
		<tr valign="top" class="class_topnav_pinstripe" id="table_topnav_pinstripe">
			<td colspan="3"><img src="../images/shim.gif" alt="Spacer" width="1" height="8"></td>
		</tr>
		<tr valign="top">
		 <td width="128" align="center" class="class_left" id="table_left"><br><img src="../images/shim.gif" alt="Spacer" width="128" height="1"><br>
	 	  This is the left navigation area.<br>
				<table id="table_left_insert" class="class_left_insert" width="112" border="0" cellspacing="0" cellpadding="3">
				<tr>
					<td>This is the left navigation area insert. It usually contains several vertical links and/or information.</td>
				</tr>
				<tr>
					<td><a href="#_PageTop">This is a Link</a></td>
				</tr>
			</table>
	      <br><a href="#_PageTop" target="_top">This is a Link</a><br>
		    </td>
			<td class="class_left_pinstripe" id="table_left_pinstripe"><img src="../images/shim.gif" alt="spacer" width="8" height="1"></td>
			<td class="class_content" id="table_content"><table border="0" cellspacing="0" cellpadding="3">
				<tr>
					<td width="550">
					<p>This is a &quot;playground&quot; for trying out different color schemes.<a href="#_PageTop" target="_top">This is a Link</a></p>
					<p>Select an area of the document to be affected (the radio buttons,) then click on a color to change it.</p>
					<br><?php echo create_color_table(); ?><br>
					<p>After you have puked your guts out a few times, you will see that most color schemes are unsuitable. You are best off with subtle colors.</p>
					<p>When you have achieved a desired color scheme, give it a name, press &quot;Submit This Color Theme,&quot; and then copy the BBCode above this text.</p>
					<p>I deliberately don&#039;t have the ability to change links (&lt;A&gt; tags) in this, as I believe that you should avoid messing with links as much as possible. They are a crucial navigation tool, and the blue/red scheme should be maintained, if at all possible. The one change I make is that I tend to make &quot;visited&quot; links a darker blue.</p>
					<p>NOTE: This was developed as a part of a working portal that was set up to design a Web site, but it is being presented as a standalone project.</p>
					<p><a href="Color_Workshop.zip">Click here to download the source as a zip file</a>.</p>
					<p>It is written in PHP, but you could just take the resultant HTML and use it directly.</p></td>
				</tr>
				<tr>
					<td width="550">&nbsp;</td>
				</tr>
			</table></td>
	 </tr>
		<tr valign="top" class="class_bottom" id="table_bottom">
			<td>&nbsp;</td>
			<td>&nbsp;</td>
			<td>This is the bottom area. We usually put a bunch of less critical links here. <a href="#_PageTop" target="_top">This is a Link</a> </td>
		</tr>
</table>
</body>
</html>
